function[out_val,k]=pedotransfer_func(input_type_str,ts_func,alpha_func,n_func,ks_func,input_val,model_str_func,opt_param)

%% preambule
% input_type_str = swc or head, depending on what I feed as input
% out_val will be swc or head depending on what was feed as input
% opt_param is a mat containing 1 or 2 values: opt_param(1) = tr,
% 
% input_type_str = 'swc';
% input_val=th_subday2(time_step);
% opt_param = [tr_func tor_func];
% model_str_func = 'vg';
% 'swc',ts_func,alpha_func,n_func,ks_func,th_subday2(time_step),'vg',[tr_func tor_func]);

%%

tr = opt_param(1);
if isnan(opt_param(2)) % if l is not defined
    tor_func=0.5;
else
    tor_func=opt_param(2);
end
%%
m = 1-1/n_func; % for vg
if strcmp(input_type_str,'swc')
    t = input_val;
    for i=1:length(t)
        t_i = t(i,1);
        se(i,1) = (t_i-tr)/(ts_func-tr);
        if strcmp(model_str_func,'vg')
            h(i,1) = (1/alpha_func)*abs((1/se(i,1))^(1/m)-1)^(1/n_func);
            if abs(1-se(i,1)) <1e-15 % doesn't work with ==0 because of numerical approx
                k(i,1)=ks_func; % vG equation doesn't work if se=1
            else
                k(i,1) =ks_func.*se(i,1)^tor_func*(1-(1-se(i,1)^(1/m))^m)^2;
            end
        elseif strcmp(model_str_func,'bc')
            %             if -1/alpha*se(i,1)^(-1/n)<-1/alpha
            h(i,1) = 1/alpha_func*se(i,1)^(-1/n_func);
            %             else
            %                 h(i,1) = 1;
            %             end
            k(i,1) = ks_func*se(i,1)^(2/n_func+tor_func+2);
            if min(input_val)<=tr
                k(i,1) = 0;
            end
            
        end
    end
    out_val = -h;
    
elseif strcmp(input_type_str,'head')
    h=input_val;
    for i=1:length(h)
        h_i = h(i,1);
        if strcmp(model_str_func,'vg')
            t(i,1) = tr+(ts_func-tr)/(1+abs(alpha_func*h_i)^n_func)^m;
            se(i,1) = (t(i,1)-tr)./(ts_func-tr);
            k(i,1) =ks_func*se(i,1)^tor_func*(1-(1-se(i,1)^(1/m))^m)^2;
        elseif strcmp(model_str_func,'bc')
            if h_i<-1/alpha_func
                t(i,1) = abs(alpha_func*h)^n_func*(ts_func-tr)+tr;
                se(i,1) = (t(i,1)-tr)./(ts_func-tr);
            else
                t(i,1) = ts_func;
            end
            k(i,1) = ks_func*se(i,1)^(2/n_func+tor_func+2);
        end
        
    end
    out_val = t;
else
    disp('bad input type')
end
if isreal(k)==0
    disp('pb')
end

% figure
% subplot(2,1,1)
% semilogx(h,t)
% ylim([0 max(ts)])
% subplot(2,1,2)
% semilogx(h,k)
% ylim([0 max(ks)])


